<template>
  <el-main>
    <!--询问笔录-->
    <el-form ref="dataForm" :model="dataForm" :label-width="formLabelWidth" :disabled="isFinish=='2'">
      <el-form-item label="案件名称">
        <el-input v-model="dataForm.causeName"></el-input>
      </el-form-item>
      <el-form-item label="案由">
        <el-input v-model="dataForm.causePoint"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="开始时间">
            <el-date-picker
              v-model="dataForm.startTime"
              :value-format="`yyyy-MM-dd HH:mm:ss`"
              type="datetime"
              placeholder="选择日期时间"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="结束时间">
            <el-date-picker
              v-model="dataForm.endTime"
              :value-format="`yyyy-MM-dd HH:mm:ss`"
              style="width: 100%"
              type="datetime"
              placeholder="选择日期时间">
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="地点">
        <el-input v-model="dataForm.site"></el-input>
      </el-form-item>
      <h1 style="text-align: center;font-weight: bold;font-size: 20px;">当事人</h1>
      <el-row>
        <el-col :span="12">
          <el-form-item label="被询问人姓名">
            <el-input v-model="dataForm.interrogeeName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="性别">
            <el-select v-model="dataForm.interrogeeSex" placeholder="请选择性别" style="width: 100%">
              <el-option
                v-for="item in reviewedSexs"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="年龄">
            <el-input v-model="dataForm.interrogeeAge"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="身份证号码">
            <el-input v-model="dataForm.interrogeeCardNo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="工作单位">
        <el-input v-model="dataForm.interrogeeUnit"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="职务">
            <el-input v-model="dataForm.interrogeeDuty"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="电话">
            <el-input v-model="dataForm.interrogeePhone"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="住址">
        <el-input v-model="dataForm.interrogeeAddress"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="邮政编码">
            <el-input v-model="dataForm.interrogeePostcode"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="询问人姓名">
            <el-input v-model="dataForm.inquisitorialNameOne"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执法编号">
            <el-input v-model="dataForm.inquirerNumberOne"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="询问人姓名">
            <el-input v-model="dataForm.inquisitorialNameTwo"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执法编号">
            <el-input v-model="dataForm.inquirerNumberTwo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="记录人姓名">
            <el-input v-model="dataForm.recorderName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="记录人单位">
            <el-input v-model="dataForm.recorderUnit"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <h1 style="text-align: center;font-weight: bold;font-size: 20px">询问问答</h1>
      <ul style="list-style: none!important;">
        <li v-for="(item,index) in dataForm.questionsAnswers" :key="index">
          <el-form-item label="问：">
            <el-input type="textarea" :row="2" v-model="item.wen"></el-input>
          </el-form-item>
          <el-form-item label="答：">
            <el-input type="textarea" :row="2" v-model="item.da"></el-input>
          </el-form-item>
        </li>
      </ul>
      <el-form-item label-width="50%">
        <el-button type="text" @click="addEle">
          <img src="../../../../assets/lawImg/addIcon.png" alt="">
        </el-button>
      </el-form-item>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(dataForm)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(dataForm)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
  import {getObj, saveObj} from "@/api/News/inquiryCause";
  import {getfindAll} from "@/api/News/useres";
  import moment from "moment";
  import WordView from '@/views/News/word-view/index'
  import {remote} from "@/api/admin/dict";

  export default {
    name: "inquiryCause",
    props: ['isShowYulan', 'id', 'isFinish', 'processId'],
    components: {
      WordView
    },
    data() {
      return {
        showView: false,
        dataForm: {
          causeName: '',
          causePoint: '',
          startTime: '',
          endTime: '',
          site: '',
          interrogeeName: '',
          interrogeeSex: '',
          interrogeeAge: '',
          interrogeeCardNo: '',
          interrogeeUnit: '',
          interrogeeDuty: '',
          interrogeePhone: '',
          interrogeeAddress: '',
          interrogeePostcode: '',
          inquisitorialNameOne: '',
          inquirerNumberOne: '',
          inquisitorialNameTwo: '',
          inquirerNumberTwo: '',
          recorderName: '',
          recorderUnit: '',
          questionsAnswers: [
            {
              wen: '',
              da: '',
            }
          ],

        },
        organPersons: [],
        reviewedSexs: [],
        formLabelWidth: "140px",
      }
    },
    created() {
      this.init();
    },
    methods: {
      init() {
        remote('sex').then(res => {
          this.reviewedSexs = res.data.data;
        });
        getObj(this.id).then((res) => {
          let v = res.data.data;
          for (let attr in v) {
            if (v[attr] == null) {
              v[attr] = "";
            }
          }
          let str = JSON.stringify(v);
          let data = JSON.parse(str);
          this.dataForm = data;
        });
        this.organPersonsData();
      },
      dataFormSubmit(type) {
        this.$refs['dataForm'].validate((valid) => {
          if (valid) {
            let obj = this;
            if ("1" == type) {
              this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
                confirmButtonText: '是',
                cancelButtonText: '否',
                type: 'warning'
              }).then(function () {
                obj.dataForm.registerState = type;
                obj.dataForm.registerId = obj.id;
                obj.dataForm.processId = obj.processId;
                saveObj(obj.dataForm).then((res) => {
                  // this.submitLoading = false;
                  // if (res.success) {
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                  // }
                })
              })
            } else {
              obj.dataForm.registerState = type;
              obj.dataForm.registerId = obj.id;
              obj.dataForm.processId = obj.processId;
              saveObj(obj.dataForm).then((res) => {
                // this.submitLoading = false;
                // if (res.success) {
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
                // }
              })
            }
          }
        })
      },
      cancel() {
        this.$emit('cancel', false);
      },
      // 点击添加
      addEle() {
        this.dataForm.questionsAnswers.push({
          wen: '',
          da: '',
        });
      },
      organPersonsData() {
        getfindAll().then(res => {
          this.organPersons = res.result
        })
      },
      busage(val) {

      },
      // word预览
      cancelWord() {
        this.showView = false;
      },
      viewVord(data) {
        if(data.registerState == null || data.registerState == ""){
          //预览前先进行保存
          data.registerState = '0';
          data.registerId = this.id;
          data.processId = this.processId;
          saveObj(data).then((res) => {
          })
        }
        //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
        //格式转换
        let wordData = this.transforData(data);
        //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
        this.showView = true;
        this.$nextTick(() => {
          this.$refs.wordInfo.init(wordData, "/wordes/inquiryCause.docx");
        })
      },
      downloadWord(data) {
        if(data.registerState == null || data.registerState == ""){
          //预览前先进行保存
          data.registerState = '0';
          data.registerId = this.id;
          data.processId = this.processId;
          saveObj(data).then((res) => {
          })
        }
        let wordData = this.transforData(data);
        WordView.methods.exportDoc(wordData, "/wordes/inquiryCause.docx", "调查询问笔录.docx");
      },
      transforData(obj) {
        let s = JSON.stringify(obj);
        let data = JSON.parse(s);

        let str = JSON.stringify(data);
        let jsonData = JSON.parse(str);
        data = jsonData;

        if (data.startTime != '' && data.startTime != null) {
          data.startTime = moment(data.startTime).format('YYYY年MM月DD日HH时mm分');
        } else {
          data.startTime = '  年  月  日  时  分'
        }

        if (data.endTime != '' && data.endTime != null) {
          data.endTime = moment(data.endTime).format('HH时mm分');
        } else {
          data.endTime = '  时  分'
        }

        return data;
      }
    },

  }
</script>

<style scoped>

</style>
